Microsoft Replication Conflict Viewer, Merge Publication

The Replication Conflict Viewer helps you view and resolve conflicts that may have occurred during replication synchronization. Conflicts occur when the same data is modified at two separate servers, for example, at a Publisher and Subscriber, or at two different Subscribers. The following conflicts can occur:

  • Update and insert conflicts. This conflict happens when the same data is changed at two locations. One change "wins," the other one "loses." For these conflicts, you have the option to keep the existing data (the data that won) or overwrite the existing data with the data that conflicted with it (the losing data). If you keep the existing data, it remains in the replica that won and the Microsoft Replication Conflict Viewer adds it to the replica whose update or insert operation initially lost. If you overwrite the existing data with the conflicting data, the replicas are changed to include the data that originally lost.

  • Delete conflicts. This conflict occurs when the same row is deleted at one location and changed at the other.

Conflicts are automatically resolved using the conflict resolver initially selected when the article was created. As conflicts are resolved during synchronization, the data from the losing row is written to a conflict table. The Replication Conflict Viewer allows you to review these conflict records and, potentially, modify your data.

When you resolve a conflict using Replication Conflict Viewer, you can choose to accept the original resolution or submit an update to the data based on the winning or losing row. In each instance, the logged conflict row is deleted from the conflict table. Thereafter, you should periodically review conflicts to help reduce the size of the conflict tracking tables.

Note The Replication Conflict Viewer displays conflicts that may occur as part merge replication, or as part of snapshot or transactional replication whenever updatable subscriptions (immediate updating or queued updating) are used. In the case of snapshot and transactional publication using updatable subscriptions, you will be able to use Replication Conflict Viewer to observe the conflict, but you will not be able to alter the resolution the way you can with conflicts that occur during merge replication synchronization.

The following options are available in the Replication Conflict Viewer dialog box for merge publications.

The specific options that appear depend on the type of conflict that has occurred. Not all options appear in all dialog boxes. Dates are displayed in ISO date-time format instead of the local format.

Options

Reason for conflict

View the reason for the conflict including where data modifications ocurred.

Show only columns with conflicts

Select to display only those columns where data modifications conflict.

Show all columns

Select to show all columns regardless of whether there is a conflict or not.

Show

Select Conflict Winner or Conflict Loser to view the data modifications made by the winner or loser that caused the conflict.

Show or edit for resolution

Select Conflict Winner or Conflict Loser to view or edit the data modifications made by the winner or loser that caused the conflict.

Keep winning change

Select to keep the winning change. The losing change will be disregarded and the winning change will be propagated to the other servers in the replication topology.

Resolve with this data

Select to resolve the conflict with the data listed. This data will be accepted and propagated to the other servers in the replication topology.

Postpone resolution

Postpones any resolution to the conflict and closes the Replication Conflict Viewer for this table.

Log the details of the conflict for later reference

Logs the details of the conflict in system tables.


Microsoft Replication Interactive Resolver

The Interactive Resolver allows you to view, compare, edit, and select the outcome data. Data that cannot be edited in the Interactive Resolver (for example, rowguid data) is displayed read-only with the box shaded. Information describing why the conflict occurred (for example, the same row was updated at both the Publisher and the Subscriber) is displayed in the Reason for conflict box.

The conflict data is displayed in two corresponding columns (Show and Show or edit for resolution), with the Subscriber data displayed in the left column beneath Show, and the suggested resolution data displayed in the right column beneath Show or edit for resolution. The Resolve With This Data button always refers to the data displayed in the right column.

If the conflict is between updated and deleted data, there may be no data to show for the deleted side of the conflict. In this case, the Interactive Resolver displays a message in one of the columns, indicating the row was deleted at one location and updated at another, and indicating the suggested resolution (conflict winner).

Options

Reason for conflict

View the reason for the conflict including where data modifications ocurred.

Show only columns with conflicts

Select to display only those columns where data modifications conflict.

Show all columns

Select to show all columns regardless of whether there is a conflict or not.

Show

Select Publisher Data or Subscriber Data to view the data modifications made by the winner or loser that caused the conflict. The starting selection in the Show dropdown is based on comparing the Publisher data to the Suggested Resolution. If the rows are different, the Publisher data is displayed. If the rows are the same, the Subscriber data is displayed.

Show or edit for resolution

Select Publisher Data, Subscriber Data or Suggested Resolution to view or edit the data modifications made by the Publisher, the Subscriber or to view or edit the suggested resolution of the Interactive Resolver.

Resolve with this data

Select to resolve the conflict with the data listed. This data will be accepted and propagated to the other servers in the replication topology.

Resolve with defaults

Postpones any resolution to the conflict and closes the Replication Conflict Viewer for this table.

Resolve all with defaults

Postpones any resolution to the conflict and closes the Replication Conflict Viewer for this table.

Log the details of the conflict for later reference

Logs the details of the conflict in system tables.

See Also

Interactive Resolver

Merge Replication Conflict Detection and Resolution


Microsoft Replication Conflict Viewer, Updatable Subscriptions

The Replication Conflict Viewer helps you view and resolve conflicts that may have occurred during replication synchronization. Conflicts occur when the same data is modified at two separate servers, for example, at a Publisher and Subscriber, or at two different Subscribers. The following conflicts can occur:

  • Update and insert conflicts. This conflict happens when the same data is changed at two locations. One change "wins," the other one "loses." For these conflicts, you have the option to keep the existing data (the data that won) or overwrite the existing data with the data that conflicted with it (the losing data). If you keep the existing data, it remains in the replica that won and the Microsoft Replication Conflict Viewer adds it to the replica whose update or insert operation initially lost. If you overwrite the existing data with the conflicting data, the replicas are changed to include the data that originally lost.

  • Delete conflicts. This conflict occurs when the same row is deleted at one location and changed at the other.

Conflicts are automatically resolved using the conflict resolver initially selected when the article was created. As conflicts are resolved during synchronization, the data from the losing row is written to a conflict table. The Replication Conflict Viewer allows you to review these conflict records and, potentially, modify your data.

The conflict resolver choices for queued updating subscriptions are:

  • Publisher wins and the subscription is reinitialized

  • Publisher wins

  • Subscriber wins

Note The Replication Conflict Viewer displays conflicts that may occur as part merge replication or as part of snapshot or transactional replication whenever updatable subscriptions (immediate updating or queued updating) are used. In the case of snapshot and transactional publication using updatable subscriptions, you will be able to use Replication Conflict Viewer to observe the conflict, but you will not be able to alter the resolution the way you can with conflicts that occur during merge replication synchronization.

The following options are available in the Replication Conflict Viewer dialog box for snapshot or transactional publications that allow updatable subscriptions.

The specific options that appear depend on the type of conflict that has occurred. Not all options appear in all dialog boxes. Dates are displayed in ISO date-time format instead of the local format.

Options

Reason for conflict

View the

Show only columns with conflicts

If creating a new stored procedure article, enter the name of the article. If the article is already created, view the name of the article.

Show all columns

If creating a new stored procedure article, enter the name of the article. If the article is already created, view the name of the article.

Show

If creating a new stored procedure article, enter the name of the article. If the article is already created, view the name of the article.

Show or edit for resolution

If creating a new stored procedure article, enter the name of the article. If the article is already created, view the name of the article.

Keep winning change

If creating a new stored procedure article, enter the name of the article. If the article is already created, view the name of the article.

Resolve with this data

If creating a new stored procedure article, enter the name of the article. If the article is already created, view the name of the article.

Postpone resolution

If creating a new stored procedure article, enter the name of the article. If the article is already created, view the name of the article.

Log the details of the conflict for later reference

If creating a new stored procedure article, enter the name of the article. If the article is already created, view the name of the article.